<template>
  <v-container>
    <base-material-input-screen
      style="width: 100%"
      title="Thêm mới"
      icon2="save"
      text2="Lưu"
      color2="primary"
      icon3="close"
      color3="red"
      :disabled1="true"
      @action-2="insertProduct()"
      @back-list="gotoPage('QLSANPHAM')"
    >
      <v-form
        ref="form"
        style="width:100%"
        class="pa-5"
      >
        <!-- Browser desktop -->
        <v-col
          cols="12"
          lg="12"
          v-if="!isMobile()"
        >
          <!-- FORM THÔNG TIN -->
          <v-row class="cols">
            <v-col
              cols="12"
              lg="5"
              class="pl-0 pt-0 pb-0 pr-5"
            >
              <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                <span>Hình ảnh</span>
              </v-row>
              <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                <v-col
                  cols="12"
                  class="text-center pt-0 pb-0 pl-0 main-thumb"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData1})` }"
                    class="image-input m-auto rounded-lg"
                    width="500px"
                    @click="chooseImage('THUMB_1')"
                  >
                    <span
                      v-if="!imageData1"
                      class="placeholder"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput1"
                      class="file-input"
                      type="file"
                      @input="onSelectFile1"
                    >
                  </div>
                </v-col>
                <v-col
                  cols="3"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData2})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_2')"
                  >
                    <span
                      v-if="!imageData2"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput2"
                      class="file-input"
                      type="file"
                      @input="onSelectFile2"
                    >
                  </div>
                </v-col>
                <v-col
                  cols="3"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData3})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_3')"
                  >
                    <span
                      v-if="!imageData3"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput3"
                      class="file-input"
                      type="file"
                      @input="onSelectFile3"
                    >
                  </div>
                </v-col>
                <v-col
                  cols="3"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData4})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_4')"
                  >
                    <span
                      v-if="!imageData4"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput4"
                      class="file-input"
                      type="file"
                      @input="onSelectFile4"
                    >
                  </div>
                </v-col>
                <v-col
                  cols="3"
                  class="pb-0 pl-0 pr-0"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData5})` }"
                    class="image-input m-auto rounded-lg thumb"
                    @click="chooseImage('THUMB_5')"
                  >
                    <span
                      v-if="!imageData5"
                      class="placeholder rounded-lg"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput5"
                      class="file-input"
                      type="file"
                      @input="onSelectFile5"
                    >
                  </div>
                </v-col>
              </v-row>
            </v-col>
            <v-col
              cols="12"
              lg="7"
              class="pl-0 pt-0 pb-0 pr-5"
            >
              <v-row class="cols">
                <v-text-field
                  ref="codeModal"
                  v-model="productModel.code"
                  label="Mã hàng (*)"
                  required
                  readonly
                  disabled
                  :rules="nameRules"
                />
              </v-row>
              <v-row class="cols">
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 col"
                >
                  <v-autocomplete
                    ref="spec"
                    v-model="productModel.specification"
                    :items="specification"
                    item-text="name"
                    item-value="id"
                    return-object
                    label="ĐVT"
                    required
                    :rules="dvtRules"
                  />
                </v-col>
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 col"
                >
                  <v-text-field
                    ref="net"
                    v-model="productModel.net"
                    label="KL Tịnh"
                    type="number"
                    :rules="nameRules"
                  />
                </v-col>
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 pr-0 col"
                >
                  <v-text-field
                    ref="qtyinventory"
                    v-model="productModel.quota_whosale"
                    label="Tồn kho tối thiểu"
                    required
                    :rules="nameRules"
                  />
                </v-col>
              </v-row>
              <v-row>
                <v-autocomplete
                  ref="category"
                  v-model="productModel.category_code"
                  :items="category"
                  item-text="name"
                  item-value="code"
                  label="Danh mục"
                  return-object
                  required
                  :rules="nameRules"
                />
              </v-row>
              <!-- Giá cả -->
              <v-row
                class="cols"
              >
                <v-col
                  sm="4"
                  md="4"
                  class="pl-0"
                >
                  <v-text-field
                    v-model="productModel.real_price"
                    label="Giá vốn"
                    class="pr-5 text-right"
                    value="0"
                  />
                </v-col>
                <v-col
                  sm="4"
                  md="4"
                >
                  <v-text-field
                    v-model="productModel.wholesale_price"
                    label="Giá sỉ"
                    class="pr-5"
                    value="0"
                  />
                </v-col>
                <v-col
                  sm="4"
                  md="4"
                  class="pr-0"
                >
                  <v-text-field
                    v-model="productModel.retail_price"
                    label="Giá lẻ"
                    value="0"
                  />
                </v-col>
              </v-row>
              <v-row>
                <v-autocomplete
                  ref="suppiler"
                  v-model="productModel.suppiler_code"
                  :items="suppiler_code"
                  return-object
                  item-text="name"
                  item-value="id"
                  label="Nhà cung cấp"
                  required
                  :rules="nameRules"
                />
              </v-row>
            </v-col>
          </v-row>

          <v-row class="mt-5">
            <v-text-field
              ref="nameproduct"
              v-model="productModel.name_product"
              :rules="nameRules"
              label="Tên hàng (*)"
              required
              clearable
              autofocus
            />
          </v-row>
          <v-row>
            <v-textarea
              ref="soTienModal"
              v-model="productModel.note"
              rows="3"
              label="Ghi chú"
              class="font-2em"
              clearable
            />
          </v-row>
        </v-col>
        <!-- End browser desktop -->

        <!-- Browser mobile -->
        <v-col
          cols="12"
          lg="12"
          class="pa-1"
          v-else
        >
          <!-- FORM THÔNG TIN -->
          <v-row class="cols">
            <v-col
              cols="12"
              lg="12"
              class="pa-1"
            >
              <v-row class="pa-1">
                <span>Hình ảnh</span>
              </v-row>
              <v-row class="pa-1">
                <v-col
                  cols="12"
                  class="text-center pt-0 pb-0 pl-0 main-thumb"
                >
                  <div
                    :style="{ 'background-image': `url(${imageData1})` }"
                    class="image-input m-auto rounded-lg"
                    width="200px"
                    @click="chooseImage('THUMB_1')"
                  >
                    <span
                      v-if="!imageData1"
                      class="placeholder"
                    >
                      PIC
                    </span>
                    <input
                      ref="fileInput1"
                      class="file-input"
                      type="file"
                      @input="onSelectFile1"
                    >
                  </div>
                </v-col>
              </v-row>
            </v-col>
            <v-col
              cols="12"
              lg="7"
              class="pl-0 pt-0 pb-0 pr-5"
            >
              <v-row
                class="cols"
                >
                <v-col
                  cols="3"
                  class="pa-1"
                >
                  <v-text-field
                    ref="codeModal"
                    v-model="productModel.code"
                    label="Mã hàng (*)"
                    required
                    readonly
                    disabled
                    :rules="nameRules"
                  />
                </v-col>
                <v-col
                  cols="9"
                  class="pa-1">
                  <v-text-field
                    ref="nameproduct"
                    v-model="productModel.name_product"
                    :rules="nameRules"
                    label="Tên hàng (*)"
                    required
                    clearable
                    autofocus
                  />
                </v-col>
              </v-row>
              <!-- NCC - DVT - DM -->
              <v-row>
                <v-col
                  col="5"
                  md="5"
                  class="pa-1"
                >
                  <v-autocomplete
                    ref="suppiler"
                    v-model="productModel.suppiler_code"
                    :items="suppiler_code"
                    return-object
                    item-text="name"
                    item-value="id"
                    label="Nhà cung cấp"
                    required
                    :rules="nameRules"
                  />
                </v-col>
                <v-col
                  col="4"
                  md="4"
                  class="pa-1"
                >
                  <v-autocomplete
                    ref="category"
                    v-model="productModel.category_code"
                    :items="category"
                    item-text="name"
                    item-value="code"
                    label="Danh mục"
                    return-object
                    required
                    :rules="nameRules"
                  />
                </v-col>
                
              </v-row>
              <!-- end NCC - DVT - DM -->
              
              <v-row class="cols">
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 col"
                >
                  <v-text-field
                    ref="net"
                    v-model="productModel.net"
                    label="KL Tịnh"
                    type="number"
                    value="100"
                    class="pr-5 text-right"
                    :rules="nameRules"
                  />
                </v-col>
                <v-col
                  md="4"
                  class="pl-0 pt-0 pb-0 pr-0 col"
                >
                  <v-text-field
                    ref="qtyinventory"
                    v-model="productModel.quota_whosale"
                    label="Tồn kho tối thiểu"
                    class="pr-5 text-right"
                    type="number"
                    value="5"
                    required
                    :rules="nameRules"
                  />
                </v-col>
                <v-col
                  col="3"
                  md="3"
                  class="pa-1"
                >
                  <v-autocomplete
                    ref="spec"
                    v-model="productModel.specification"
                    :items="specification"
                    item-text="name"
                    item-value="id"
                    return-object
                    label="ĐVT"
                    required
                    :rules="dvtRules"
                  />
                </v-col>
              </v-row>
              
              <!-- Giá cả -->
              <v-row
                class="cols"
              >
                <v-col
                  sm="4"
                  md="4"
                  class="pl-0"
                >
                  <v-text-field
                    v-model="productModel.real_price"
                    label="Giá vốn"
                    type="number"
                    class="pr-5 text-right"
                    value="0"
                  />
                </v-col>
                <v-col
                  sm="4"
                  md="4"
                >
                  <v-text-field
                    v-model="productModel.wholesale_price"
                    label="Giá sỉ"
                    class="pr-5 text-right"
                    type="number"
                    value="0"
                    :rules="giaSiBanRule"
                  />
                </v-col>
                <v-col
                  sm="4"
                  md="4"
                  class="pr-0"
                >
                  <v-text-field
                    v-model="productModel.retail_price"
                    label="Giá lẻ"
                    class="pr-5 text-right"
                    type="number"
                    value="0"
                    :rules="giaLeBanRule"
                  />
                </v-col>
              </v-row>
              
            </v-col>
          </v-row>
          <v-row>
            <v-textarea
              ref="soTienModal"
              v-model="productModel.note"
              rows="3"
              label="Ghi chú"
              class="font-2em"
              clearable
            />
          </v-row>
          <v-row>
            <snackbarNew
              ref="snackNotification"
              :v-model="snackbar"
            />
          </v-row>
        </v-col>
        
        <!-- En browser mobile -->
      </v-form>
    </base-material-input-screen>
  </v-container>

</template>

<script>
  import axios from 'axios'
  import config from '../../config/config.js'
  import totalOrder from '../sales/TotalOrder'
  import snackbarNew from '../dashboard/component/snackbarNew'
  export default {
    layout: 'dashboard',
    components: {
        totalOrder,
        snackbarNew,  },
    data () {
      return {
        valid: false,
        dialog: false,
        snackbar: false,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        panel: [0, 1, 2],
        imageData1: null,
        imageData2: null,
        imageData3: null,
        imageData4: null,
        imageData5: null,
        specification: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        suppiler_code: [],
        category: [],
        nameRules: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
        required: [(v) => !!v || 'The field is required'],
        giaLeBanRule: [ 
            v => !!v || "Giá trị bắt buộc nhập",
            v => ( v && v >= this.productModel.real_price ) || "Giá lẻ nên lớn hơn giá vốn",
            v => ( v && v >= this.productModel.real_price ) || "Giá lẻ nên lớn hơn giá sỉ",
        ],
        giaSiBanRule: [ 
            v => !!v || "Giá trị bắt buộc nhập",
            v => ( v && v >= this.productModel.real_price ) || "Giá sỉ nên lớn hơn giá vốn",
            v => ( v && v <= this.productModel.retail_price ) || "Giá sỉ nên nhỏ hơn giá lẻ",
        ],
        giaVonBanRule: [ 
            v => !!v || "Giá trị bắt buộc nhập",
            v => ( v && v <= this.productModel.wholesale_price ) || "Giá vốn nên lớn hơn giá sỉ",
            v => ( v && v <= this.productModel.retail_price ) || "Giá vốn nên lớn hơn giá lẻ",
        ],
        seqOb: {
          seqCode: 'SP',
          seqName: 'product_code_seq',
          seqDigitNumber: 5,
        },
        productModel: {
          code: '',
          name_product: '',
          category_code: '',
          specification: '',
          suppiler_code: '',
          net: '100',
          wholesale_price: '0',
          retail_price: '0',
          quota_whosale: '5',
          quatity_inventory: '0',
          note: '',
          img_url:
            '{ "thumbs": "https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d" }',
          real_price: '0',
          create_user: '1',
        },

      }
    },
    computed: {},
    mounted: function () {}, // end method
    created () {
      this.setSeqByName()
      this.selectSuppliers()
      this.getSpecs()
      this.getCategories()
      console.log('this.$router.params')
      if (this.$route.params.id !== undefined && this.$route.params.id != null) {
        this.selectProductDetail(this.$route.params.id)
      }
    }, // end data
    methods: {
      isMobile() {
        if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          return true
        } else {
          return false
        }
      },
      snackbaralert (...args) {
        if (args === undefined || args < 3) {
          this.$refs.snackNotification.color = this.colors[4]
          this.$refs.snackNotification.snackbarContent =
            'Đã có lỗi xảy ra, vui lòng liên hệ admin'
          this.$refs.snackNotification.snackbar = true
        } else {
          this.$refs.snackNotification.color = args[0]
          this.$refs.snackNotification.snackbarContent = args[1]
          this.$refs.snackNotification.snackbar = true
        }
      },
      gotoPage (page) {
        this.$router.push({ name: page })
      },
      checkGiaBan () {
        console.log('checkGiaBan')
        console.log(this.productModel)
        if(this.productModel.real_price >= this.productModel.wholesale_price){
          //Giá sỉ
          this.snackbaralert(this.colors[4], 'Giá bán sỉ nhỏ hơn giá vốn! Bán lỗ')
          return
        }
        if(this.productModel.real_price >= this.productModel.retail_price){
          //Giá lẻ
           this.snackbaralert(this.colors[4], 'Giá bán lẻ nhỏ hơn giá vốn! Bán lỗ')
           return
        }

        //
      },
      async insertProduct () {
        console.log('insertProduct')

        this.validate()
        const seft = this
      
        await axios
          .post(config.API_FAMILY + '/api/insertProduct', seft.productModel)
          .then(function (response) {
            // productModel = {};
            seft.dialog = false
            console.log(response.data.data)
            seft.$emit('refeshList')
            seft.$router.push({ name: 'QLSANPHAM' })
          })
          .catch(function (error) {
            // handle error
            console.log(error)
          })
          .then(function () {
            console.log('then')

          // always executed
          })
      },
      deleteProduct () {
        alert('deleteProduct')
      },
      refeshList () {
        this.$emit('refeshList')
      },
      resetValid () {
        console.log('resetValid')
        this.$refs.form.reset()
      // this.$refs.nameproduct.reset();
      },
      validate () {
        debugger
        console.log('vaild')
        this.$refs.form.validate()
        this.$nextTick(function () {
          // Product name
          if (!this.$refs.nameproduct.validate()) {
            this.$refs.nameproduct.focus()
          } else if (!this.$refs.spec.validate()) {
            this.$refs.spec.focus()
          } else if (!this.$refs.net.validate()) {
            this.$refs.net.focus()
          } else if (!this.$refs.category.validate()) {
            this.$refs.category.focus()
          } else if (!this.$refs.suppiler.validate()) {
            this.$refs.suppiler.focus()
          }

        //  this.setFirstFocusInput(".v-dialog--active",'input, textarea, select', '.v-text-field__slot input[required="required"]');
        })
      },
      chooseImage (ref) {
        if (ref === 'THUMB_1') {
          this.$refs.fileInput1.click()
        }
        if (ref === 'THUMB_2') {
          this.$refs.fileInput2.click()
        }
        if (ref === 'THUMB_3') {
          this.$refs.fileInput3.click()
        }
        if (ref === 'THUMB_4') {
          this.$refs.fileInput4.click()
        }
        if (ref === 'THUMB_5') {
          this.$refs.fileInput5.click()
        }
      },
      onSelectFile1 () {
        console.log('onSelectFile1')
        const input = this.$refs.fileInput1
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData1 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },

      onSelectFile2 () {
        console.log('onSelectFile2')
        const input = this.$refs.fileInput2
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData2 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile3 () {
        console.log('onSelectFile3')
        const input = this.$refs.fileInput3
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData3 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile4 () {
        console.log('onSelectFile4')
        const input = this.$refs.fileInput4
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData4 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      onSelectFile5 () {
        console.log('onSelectFile5')
        const input = this.$refs.fileInput5
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = e => {
            this.imageData5 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      async setSeqByName () {
        let productCode = 'SP'
        // this.$refs.nameproduct.focus()
        // this.$refs.form.reset()
        console.log('setSeqByName')
        const self = this
        let dataRes = null
        await axios
          .post(config.API_FAMILY + '/api/getSeqbyName', this.seqOb)
          .then(function (response) {
            console.log('response_setSeqByName')
            console.log(response.data.data)
            dataRes = response.data.data
            if (dataRes !== undefined && dataRes != null) {
              productCode = dataRes.seq
              // self.$refs.productModel = productModel
            }
          })
        this.productModel.code = productCode
        console.log('response_setSeqByName:' + productCode)
      },
      async selectSuppliers () {
        const self = this
        // this.$refs.nameproduct.focus()
        // this.$refs.form.reset()
        console.log('selectSuppliers')
        let dataRes = null
        await axios
          .get(config.API_FAMILY + '/api/selectSuppliers')
          .then(function (response) {
            console.log('response_setSeqByName')
            console.log(response.data.data)
            dataRes = response.data.data
            if (dataRes !== undefined && dataRes != null) {
              self.suppiler_code = dataRes
              // self.$refs.productModel = productModel
            }
          })
      },
      async selectProductDetail (id) {
        const self = this
        // this.$refs.nameproduct.focus()
        // this.$refs.form.reset()
        
        let dataRes = null
        await axios
          .get(config.API_FAMILY + '/api/selectProductbyId/' + id)
          .then(function (response) {
            console.log('selectProductbyId')
            console.log(response.data.data)
            dataRes = response.data.data
            if (dataRes !== undefined && dataRes != null) {
              self.productModel = dataRes[0]
            }

           
          })
      },
      async getSpecs () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getSpecs')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.specification = response.data.data
          })
      },
      async getCategories () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCategories')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.category = response.data.data
          })
      },
    }, // end method
  } // End exxport defaul
</script>
<style scroped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
.table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
}
.image-input{
  display: block;
  max-width:100%;
  height:250px;
  cursor: pointer                  ;
  background-size: cover            ;
  background-position: center center;
  border-radius: 4px;
}
.image-input.thumb{
  display: block;
  max-width:70px;
  height:70px;
  cursor: pointer                  ;
  background-size: cover            ;
  background-position: center center;
  border-radius: 4px;
}
.placeholder{
  background: #F0F0F0     ;
  width: 100%             ;
  height: 100%            ;
  display: flex           ;
  justify-content: center ;
  align-items: center     ;
  color: #333             ;
  font-size: 18px         ;
  font-family: Helvetica   ;
}
.placeholder:hover{
  background: #E0E0E0;
}
.file-input{
  display: none;

}

.main-thumb .placeholder{
  border-radius: 8px;
}

</style>
